hnb (1.9.17-4)  * Add recursive expand/collapse.  (Closes: #248798)

--- hnb-1.9.18.orig/src/expanded.c
+++ hnb-1.9.18/src/expanded.c
@@ -26,7 +26,6 @@
 #include "ctype.h"
 #include "ui_binding.h"
 
-
 static int cmd_expand (int argc,char **argv, void *data)
 {
 	Node *pos = (Node *) data;
@@ -47,6 +46,18 @@ static int cmd_expand (int argc,char **a
 			tnode = node_recurse (tnode);
 		}
 		cli_outfun ("expanded all nodes");
+	} else if(!strcmp(argv[1],"--subtree")) {
+	        node_setflag(pos,F_expanded,1);
+		if(node_right(pos)) {
+
+		  Node *tnode = node_right(pos);
+
+		  while (tnode) {
+		    node_setflag(tnode,F_expanded,1);
+		    tnode = node_traverse_right_of (pos, tnode);
+		  }
+		}
+		cli_outfun ("expanded subtree");
 	}
 	return (int) pos;
 }
@@ -71,6 +82,17 @@ static int cmd_collapse (int argc,char *
 			tnode = node_recurse (tnode);
 		}
 		cli_outfun ("collapsed all nodes");
+	} else if(!strcmp(argv[1],"--subtree")) {
+	        node_setflag(pos,F_expanded,0);
+		if(node_right(pos)) {
+		  Node *tnode = node_right(pos);
+
+		  while (tnode) {
+		    node_setflag(tnode,F_expanded,0);
+		    tnode = node_traverse_right_of (pos, tnode);
+		  }
+		}
+		cli_outfun ("collapsed subtree");
 	}
 	
 	return (int) pos;
--- hnb-1.9.18.orig/src/tree.c
+++ hnb-1.9.18/src/tree.c
@@ -47,6 +47,21 @@ Node *node_recurse (Node *node)
 	return 0;
 }
 
+Node *node_traverse_right_of (Node *stop, Node *node)
+{
+	if (node_right (node))
+		return node_right (node);
+	if (node_down (node))
+		return node_down (node);
+	while (node_left (node) && (node_left (node) != stop)) {
+		if (node_down (node_left (node)))
+			return node_down (node_left (node));
+		node = node_left (node);
+	}
+
+	return 0;
+}
+
 Node *node_backrecurse (Node *node)
 {
 	if (node_up (node)) {
